/*-----------------------------------------------------------------
LOG
    GEM - Graphics Environment for Multimedia

    A cone

    Copyright (c) 1997-2000 Mark Danks. mark@danks.org
    Copyright (c) Gnther Geiger. geiger@epy.co.at
    Copyright (c) 2001-2002 IOhannes m zmoelnig. forum::fr::umlute. IEM. zmoelnig@iem.kug.ac.at
    For information on usage and redistribution, and for a DISCLAIMER OF ALL
    WARRANTIES, see the file, "GEM.LICENSE.TERMS" in this distribution.

-----------------------------------------------------------------*/

#ifndef INCLUDE_CONE_H_
#define INCLUDE_CONE_H_

#include "Base/GemGluObj.h"

/*-----------------------------------------------------------------
-------------------------------------------------------------------
CLASS
    cone
    
    Creates a cone

KEYWORD
    geo
    
DESCRIPTION

-----------------------------------------------------------------*/
class GEM_EXTERN cone : public GemGluObj
{
    CPPEXTERN_HEADER(cone, GemGluObj)

    public:

	    //////////
	    // Constructor
    	cone(t_floatarg size);
    	
    protected:
    	
    	//////////
    	// Destructor
    	virtual ~cone();

    	//////////
    	// Do the rendering
    	virtual void 	render(GemState *state);
};

#endif	// for header file
